<?php

define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
   $filename = basename(__FILE__);
   $module['General']['Anti_Spam'] = $filename;

   return;
}
//
// Load default header
//
$phpbb_root_path = "./../";
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
include($phpbb_root_path . 'includes/functions_admin.'.$phpEx);

$mode=$_GET['mode'];
$confirm=$_GET['confirm'];

function DispMessage($template, $title, $msg)
{

	$template->set_filenames(array(
		"body" => "admin/admin_message_body.tpl"
	));
		
	$template->assign_vars(array(
		'MESSAGE_TITLE' => $title,
		'MESSAGE_TEXT' => $msg
	));
	$template->pparse("body");
	exit;
}

if($mode == ""){

	$sql = "SELECT * FROM " . $table_prefix . "antispam";
	
	if ( !($result = $db->sql_query($sql)) ) {
		message_die(GENERAL_ERROR, 'Error retrieving antispam data', '', __LINE__, __FILE__, $sql);
	}
	if ( $db->sql_numrows($result) == 0){
		$template->assign_block_vars('switch_no_entries',array() ); 
	} else{
		$counter = 0;
		while ( $row = $db->sql_fetchrow($result) ) {
			$filename = $db->sql_fetchfield('Filename');
			$alttext = $db->sql_fetchfield('Alt-Text');
			$Option1 = $db->sql_fetchfield('Option1');
			$Option2 = $db->sql_fetchfield('Option2');
			$Option3 = $db->sql_fetchfield('Option3');
			$correct = $db->sql_fetchfield('CorrectOption') % 3 + 1;
			$template->assign_block_vars('entries_loop',array( 'IMAGE_PATH' => $phpbb_root_path . 'images/antispam/' . $filename, 'IMAGE_ALT' => $alttext, 'OPTION1' => $Option1, 'OPTION2' => $Option2, 'OPTION3' => $Option3, 'EDIT_LINK' => append_sid('admin_antispam.' . $phpEx . '?mode=edit&amp;num=' . $counter), 'DEL_LINK' => append_sid('admin_antispam.' . $phpEx . '?mode=del&amp;num=' . $counter), 'CORRECT' => $correct));
			$counter++;
		}
	}
	$template->set_filenames(array(
		"body" => "admin/admin_main_antispam.tpl"
	));
	
	$template->assign_vars(array(
		'FORM_ACTION' => append_sid('admin_antispam.' . $phpEx . '?mode=add'),
		'TITLE' => 'eXtreme Antispam Control Panel',
		'NO_ENTRIES' => 'NO ENTRIES YET',
		'OPT0SEL' => ($correct == 0) ? ' selected="selected"' : '',
		'OPT1SEL' => ($correct == 1) ? ' selected="selected"' : '',
		'OPT2SEL' => ($correct == 2) ? ' selected="selected"' : '',
		'FILENAME' => $filename,
		'OPT0' => $Option1,
		'OPT1' => $Option2,
		'OPT2' => $Option3,
		'ALT' => $alttext
	));
	$template->pparse("body");
	exit;

} else if($mode == "add"){
	$filename = str_replace("\'", "''", $_POST['filename']);
	$alttext = str_replace("\'", "''", $_POST['alttext']);
	$option1 = str_replace("\'", "''", $_POST['option1']);
	$option2 = str_replace("\'", "''", $_POST['option2']);
	$option3 = str_replace("\'", "''", $_POST['option3']);
	$correct = intval(str_replace("\'", "''", $_POST['correct'])) % 3;
	$sql = "INSERT INTO `phpbb_antispam` (`Filename`, `Option1`, `Option2`, `Option3`, `Alt-Text`, `CorrectOption`) VALUES ('" . $filename . "', '" .$option1 ."', '" . $option2 . "', '" . $option3 . "', '" . $alttext . "', '" . $correct . "')";
	if ( !($result = $db->sql_query($sql)) ) {
		message_die(GENERAL_ERROR, 'Error posting', '', __LINE__, __FILE__, $sql);
	} else{
		DispMessage($template, 'SUCCESS!', 'Operation Successful. Click <a href="' . append_sid('admin_antispam.' . $phpEx) . '">here</a> to return to Antispam Control.');
	}
} else if($mode == "del"){
	$sql = "SELECT * FROM " . $table_prefix . "antispam";
	
	if ( !($result = $db->sql_query($sql)) ) {
		message_die(GENERAL_ERROR, 'Error retrieving antispam data', '', __LINE__, __FILE__, $sql);
	}
	$total = $db->sql_numrows($result);
	$requested = $_GET['num'];
	
	if($confirm == "delete" && intval($requested) < $total && intval($requested) >= 0) {
		if($total == 1){
			DispMessage($template, 'Error!!!', 'You can\'t delete the last entry. Click <a href="' . append_sid('admin_antispam.' . $phpEx) . '">here</a> to return to Antispam Control.');
		}
		$db->sql_rowseek($requested, $result);
		$db->sql_fetchrow($result);
		$filename = $db->sql_fetchfield('Filename');
		$alttext = $db->sql_fetchfield('Alt-Text');
		$Option1 = $db->sql_fetchfield('Option1');
		$Option2 = $db->sql_fetchfield('Option2');
		$Option3 = $db->sql_fetchfield('Option3');
		$correct = $db->sql_fetchfield('CorrectOption');
		$sql = "DELETE FROM `phpbb_antispam` WHERE `Filename`='". $filename ."'AND `Option1`='". $Option1 ."' AND `Option2`='". $Option2 ."' AND `Option3`='". $Option3 ."' AND `Alt-Text`='". $alttext ."' AND `CorrectOption`='". $correct ."' LIMIT 1";
		if ( !($result = $db->sql_query($sql)) ) {
			message_die(GENERAL_ERROR, 'Error deleting antispam data', '', __LINE__, __FILE__, $sql);
		}
		DispMessage($template, 'SUCCESS!', 'Operation Successful.  Click <a href="' . append_sid('admin_antispam.' . $phpEx) . '">here</a> to return to Antispam Control.');
	} else if($confirm != "delete"){
		DispMessage($template, 'Confirm Delete:', 'Do you really want to delete this entry? <a href="' . append_sid('admin_antispam.' . $phpEx . '?mode=del&amp;confirm=delete&amp;num=' . $requested) . '">YES</a>&nbsp;||&nbsp;<a href="' . append_sid('admin_antispam.' . $phpEx) . '">NO</a>.');
	} else{
		DispMessage($template, 'ERROR!!!', 'You attempted to delete a non existant entry. Click <a href="' . append_sid('admin_antispam.' . $phpEx) . '">here</a> to return to Antispam Control.');
	}

} else if($mode == "edit"){
	$sql = "SELECT * FROM " . $table_prefix . "antispam";
	
	if ( !($result = $db->sql_query($sql)) ) {
		message_die(GENERAL_ERROR, 'Error retrieving antispam data', '', __LINE__, __FILE__, $sql);
	}
	$total = $db->sql_numrows($result);
	$requested = $_GET['num'];
	
	if($confirm!="edit" && intval($requested) < $total && intval($requested) >= 0) {
		$db->sql_rowseek($requested, $result);
		$db->sql_fetchrow($result);
		$filename = $db->sql_fetchfield('Filename');
		$alttext = $db->sql_fetchfield('Alt-Text');
		$Option1 = $db->sql_fetchfield('Option1');
		$Option2 = $db->sql_fetchfield('Option2');
		$Option3 = $db->sql_fetchfield('Option3');
		$correct = $db->sql_fetchfield('CorrectOption');
		$sql = "DELETE FROM `" . $table_prefix . "antispam` WHERE `Filename`='". $filename ."' AND `Option1`='". $option1 ."' AND `Option2`='". $option2 ."' AND `Option3`='". $option3 ."' AND `Alt-Text`='". $alttext ."' AND `CorrectOption`='". $correct ."' LIMIT 1";
		if ( !($result = $db->sql_query($sql)) ) {
			message_die(GENERAL_ERROR, 'Error deleting antispam data', '', __LINE__, __FILE__, $sql);
		}
		
		$template->set_filenames(array(
			"body" => "admin/admin_edit_antispam.tpl"
		));
		
		$template->assign_vars(array(
			'FORM_ACTION' => append_sid('admin_antispam.' . $phpEx . '?mode=edit&amp;num=' . $requested . '&amp;confirm=edit'),
			'TITLE' => 'Edit Antispam Entry',
			'OPT0SEL' => ($correct == 0) ? ' selected="selected"' : '',
			'OPT1SEL' => ($correct == 1) ? ' selected="selected"' : '',
			'OPT2SEL' => ($correct == 2) ? ' selected="selected"' : '',
			'FILENAME' => $filename,
			'OPT0' => $Option1,
			'OPT1' => $Option2,
			'OPT2' => $Option3,
			'ALT' => $alttext
		));
		$template->pparse("body");
		exit;
		
	}else if($confirm=="edit" && intval($requested) < $total && intval($requested) >= 0) {
		$filename = str_replace("\'", "''", $_POST['filename']);
		$alttext = str_replace("\'", "''", $_POST['alttext']);
		$option1 = str_replace("\'", "''", $_POST['option1']);
		$option2 = str_replace("\'", "''", $_POST['option2']);
		$option3 = str_replace("\'", "''", $_POST['option3']);
		$correct = intval(str_replace("\'", "''", $_POST['correct'])) % 3;
		
		$sql = "SELECT * FROM " . $table_prefix . "antispam";
		if ( !($result = $db->sql_query($sql)) ) {
			message_die(GENERAL_ERROR, 'Error retrieving antispam data', '', __LINE__, __FILE__, $sql);
		}
		$db->sql_rowseek($requested, $result);
		$db->sql_fetchrow($result);
		$filename_old = $db->sql_fetchfield('Filename');
		$alttext_old = $db->sql_fetchfield('Alt-Text');
		$Option1_old = $db->sql_fetchfield('Option1');
		$Option2_old = $db->sql_fetchfield('Option2');
		$Option3_old = $db->sql_fetchfield('Option3');
		$correct_old = $db->sql_fetchfield('CorrectOption');
		$sql = "UPDATE `" . $table_prefix . "antispam` SET `Filename`='". $filename ."', `Option1`='". $option1 ."', `Option2`='". $option2 ."', `Option3`='". $option3 ."', `Alt-Text`='". $alttext ."', `CorrectOption`='". $correct ."' WHERE `Filename`='". $filename_old ."' AND `Option1`='". $Option1_old ."' AND `Option2`='". $Option2_old ."' AND `Option3`='". $Option3_old ."' AND `Alt-Text`='". $alttext_old ."' AND `CorrectOption`='". $correct_old ."' LIMIT 1";
		if ( !($result = $db->sql_query($sql)) ) {
			message_die(GENERAL_ERROR, 'Error updating antispam data', '', __LINE__, __FILE__, $sql);
		}
		DispMessage($template, 'SUCCESS!', 'Operation Successful! Click <a href="' . append_sid('admin_antispam.' . $phpEx) . '">here</a> to return to Antispam Control.');
	} else{
		DispMessage($template, 'ERROR!!!', 'You attempted to edit a non existant entry. Click <a href="' . append_sid('admin_antispam.' . $phpEx) . '">here</a> to return to Antispam Control.');
	}		
}
?>